import java_cup.runtime.Symbol;
import java.math.BigInteger;
import reducer.*;
/*
 *   Copyright (C) A C Norman, April 2000
 *   Permission is given to use this code in any way you want for
 *   purposes directly concerned with the University of Cambridge taught
 *   courses in Computer Science and associated study. Anybody who
 *   wants to re-distribute this code or use it commercially should
 *   check with ACN (acn1@cam.ac.uk) first.
 *
 *   Note that CUP and Jlex have their own (liberal) copyrights: see their
 *   documentation.
 */


class Yylex implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int SLASHSLASHCOMMENT = 2;
	private final int SLASHSTARCOMMENT = 1;
	private final int ATEOF = 3;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0,
		70,
		84,
		96
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NOT_ACCEPT,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NOT_ACCEPT,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NOT_ACCEPT,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NOT_ACCEPT,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NOT_ACCEPT,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NOT_ACCEPT,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NOT_ACCEPT,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NOT_ACCEPT,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NOT_ACCEPT,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NOT_ACCEPT,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NOT_ACCEPT,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NOT_ACCEPT,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NOT_ACCEPT,
		/* 95 */ YY_NO_ANCHOR,
		/* 96 */ YY_NOT_ACCEPT,
		/* 97 */ YY_NO_ANCHOR,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NO_ANCHOR,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NO_ANCHOR,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NO_ANCHOR,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NO_ANCHOR,
		/* 107 */ YY_NO_ANCHOR,
		/* 108 */ YY_NO_ANCHOR,
		/* 109 */ YY_NO_ANCHOR,
		/* 110 */ YY_NO_ANCHOR,
		/* 111 */ YY_NO_ANCHOR,
		/* 112 */ YY_NO_ANCHOR,
		/* 113 */ YY_NO_ANCHOR,
		/* 114 */ YY_NO_ANCHOR,
		/* 115 */ YY_NO_ANCHOR,
		/* 116 */ YY_NO_ANCHOR,
		/* 117 */ YY_NO_ANCHOR,
		/* 118 */ YY_NO_ANCHOR,
		/* 119 */ YY_NO_ANCHOR,
		/* 120 */ YY_NO_ANCHOR,
		/* 121 */ YY_NO_ANCHOR,
		/* 122 */ YY_NO_ANCHOR,
		/* 123 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"41:4,40,41:4,42,39,41,39:2,41:12,40,41:5,42,9,41:3,5,41,38,21,22,3,1,25,2,4" +
"1,4,37:10,18,19,6,8,7,41:2,36:26,23,41,24,41,28,41,15,36,35,17,12,32,36,33," +
"29,36:2,13,36,16,10,20,36,11,14,31,30,34,36:4,41,27,41,26,41,0:2")[0];

	private int yy_rmap[] = unpackFromString(1,124,
"0,1:2,2,1,3,1,4,5,6,7,8,9,1:8,10,11,1:9,12:2,1,13,12:3,14,12:3,15,12:12,1:9" +
",16:2,17,18,19,20,1,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,3" +
"9,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,6" +
"4,65,12,66,67,68,69,70,71")[0];

	private int yy_nxt[][] = unpackFromString(72,43,
"1,2,3,4,5,6,7,8,9,10,11,67,114,116,117,72,118,117,12,13,117,14,15,16,17,18," +
"19,20,21,75,119,120,77,117,121,117:2,22,66,23,24,71,23,-1:50,25,-1:38,26,27" +
",-1:46,28,-1:42,29,-1:41,30,-1:43,31,-1:44,117,122,117:6,-1:2,32,-1:7,117:1" +
"0,-1:23,34,-1:34,35:8,-1:2,35,-1:8,35:8,-1:43,22,-1:15,117:8,-1:2,117,-1:7," +
"117:10,-1:15,35:8,-1:2,35,-1:7,35:10,-1:15,39:8,-1:2,39,-1:7,39:10,-1:15,11" +
"7:5,109,117:2,-1:2,117,-1:7,117:10,-1:15,39:8,-1:2,39,-1:7,39:9,-1,65,-1:14" +
",117:2,79,117:5,-1:2,117,-1:7,117:10,-1:9,58,-1:50,86,-1:30,1,56:2,68,56,73" +
",56:33,57,56:3,-1:10,117:4,33,117,89,117,-1:2,117,-1:7,117:10,-1:17,74,-1:4" +
"0,76,-1:42,117:6,36,117,-1:2,117,-1:7,117:4,37,117:5,-1:37,78,-1:20,117:5,9" +
"9,38,117,-1:2,117,-1:7,117:2,100,117:7,-1:39,80,-1:18,117:8,-1:2,117,-1:7,1" +
"17:7,40,117:2,-1:20,82,-1:37,117:4,102,117:3,-1:2,117,-1:7,117:10,-1:18,59," +
"-1:39,117:7,41,-1:2,117,-1:7,117:10,-1:5,1,60:4,69,60:33,61,60:3,-1:10,117:" +
"8,-1:2,117,-1:7,117:7,103,117:2,-1:15,88,-1:42,117:8,-1:2,117,-1:7,117:3,42" +
",117:6,-1:37,90,-1:20,117:7,43,-1:2,117,-1:7,117:10,-1:39,92,-1:18,117:8,-1" +
":2,117,-1:7,117:3,44,117:6,-1:20,94,-1:37,117:3,45,117:4,-1:2,117,-1:7,117:" +
"10,-1:18,62,-1:39,117:8,-1:2,117,-1:7,117,104,117:8,-1:5,1,63:38,64,63:3,-1" +
":10,117:8,-1:2,117,-1:7,117:2,105,117:7,-1:15,117:2,106,117:5,-1:2,117,-1:7" +
",117:10,-1:15,117:3,107,117:4,-1:2,117,-1:7,117:10,-1:15,117:6,46,117,-1:2," +
"117,-1:7,117:10,-1:15,117:3,47,117:4,-1:2,117,-1:7,117:10,-1:15,117:2,48,11" +
"7:5,-1:2,117,-1:7,117:10,-1:15,117:5,108,117:2,-1:2,117,-1:7,117:10,-1:15,1" +
"17:8,-1:2,117,-1:7,117:3,49,117:6,-1:15,117:2,50,117:5,-1:2,117,-1:7,117:10" +
",-1:15,117:6,51,117,-1:2,117,-1:7,117:10,-1:15,117:4,110,117:3,-1:2,117,-1:" +
"7,117:10,-1:15,117:3,52,117:4,-1:2,117,-1:7,117:10,-1:15,117:3,112,117:4,-1" +
":2,117,-1:7,117:10,-1:15,117:2,53,117:5,-1:2,117,-1:7,117:10,-1:15,117:2,54" +
",117:5,-1:2,117,-1:7,117:10,-1:15,117:4,113,117:3,-1:2,117,-1:7,117:10,-1:1" +
"5,55,117:7,-1:2,117,-1:7,117:10,-1:15,117:3,81,117:2,83,117,-1:2,117,-1:7,1" +
"17:10,-1:15,117:4,111,117:3,-1:2,117,-1:7,117:10,-1:15,85,117,87,117:5,-1:2" +
",117,-1:7,117:10,-1:15,91,117:7,-1:2,117,-1:7,117,93,117:8,-1:15,117:6,95,1" +
"17,-1:2,117,-1:7,117:10,-1:15,117,97,117:6,-1:2,117,-1:7,117:5,98,117:4,-1:" +
"15,117:5,101,117:2,-1:2,117,-1:7,117:10,-1:15,117:2,123,117:5,-1:2,117,-1:7" +
",117:10,-1:15,117:3,115,117:4,-1:2,117,-1:7,117:10,-1:5");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

                        return new Symbol(sym.EOF);
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ return new Symbol(sym.PLUS, new PlusCombinator()); }
					case -3:
						break;
					case 3:
						{ return new Symbol(sym.MINUS, new DifferenceCombinator()); }
					case -4:
						break;
					case 4:
						{ return new Symbol(sym.TIMES, new TimesCombinator()); }
					case -5:
						break;
					case 5:
						{ return new Symbol(sym.DIVIDE, new QuotientCombinator()); }
					case -6:
						break;
					case 6:
						{ return new Symbol(sym.REMAINDER, new RemainderCombinator()); }
					case -7:
						break;
					case 7:
						{ return new Symbol(sym.LESS, new LtCombinator()); }
					case -8:
						break;
					case 8:
						{ return new Symbol(sym.GREATER, new GtCombinator()); }
					case -9:
						break;
					case 9:
						{ return new Symbol(sym.EQUAL, new EqCombinator()); }
					case -10:
						break;
					case 10:
						{ System.err.println("Illegal character: "+yytext()); }
					case -11:
						break;
					case 11:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -12:
						break;
					case 12:
						{ return new Symbol(sym.COLON); }
					case -13:
						break;
					case 13:
						{ return new Symbol(sym.SEMICOLON); }
					case -14:
						break;
					case 14:
						{ return new Symbol(sym.LPAR); }
					case -15:
						break;
					case 15:
						{ return new Symbol(sym.RPAR); }
					case -16:
						break;
					case 16:
						{ return new Symbol(sym.LBRACKET); }
					case -17:
						break;
					case 17:
						{ return new Symbol(sym.RBRACKET); }
					case -18:
						break;
					case 18:
						{ return new Symbol(sym.COMMA); }
					case -19:
						break;
					case 19:
						{ return new Symbol(sym.NEGATE); }
					case -20:
						break;
					case 20:
						{ return new Symbol(sym.VBAR); }
					case -21:
						break;
					case 21:
						{ return new Symbol(sym.UNDERSCORE); }
					case -22:
						break;
					case 22:
						{ return new Symbol(sym.NUMBER, new BigInteger(yytext())); }
					case -23:
						break;
					case 23:
						{ /* ignore white space. */ }
					case -24:
						break;
					case 24:
						{ yybegin(ATEOF);
                        /* I have some pain over EOF, which this does not
			   totally fix... */
                        return new Symbol(sym.EOF);
	              }
					case -25:
						break;
					case 25:
						{ return new Symbol(sym.ARROW); }
					case -26:
						break;
					case 26:
						{ yybegin(SLASHSTARCOMMENT); }
					case -27:
						break;
					case 27:
						{ yybegin(SLASHSLASHCOMMENT); }
					case -28:
						break;
					case 28:
						{ return new Symbol(sym.LESSEQ, new LeCombinator()); }
					case -29:
						break;
					case 29:
						{ return new Symbol(sym.GREATEREQ, new GeCombinator()); }
					case -30:
						break;
					case 30:
						{ return new Symbol(sym.BIGARROW); }
					case -31:
						break;
					case 31:
						{ return new Symbol(sym.NOTEQUAL, new NeCombinator()); }
					case -32:
						break;
					case 32:
						{ return new Symbol(sym.OP); }
					case -33:
						break;
					case 33:
						{ return new Symbol(sym.AS); }
					case -34:
						break;
					case 34:
						{ return new Symbol(sym.CONS, new PCombinator()); }
					case -35:
						break;
					case 35:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -36:
						break;
					case 36:
						{ return new Symbol(sym.IN); }
					case -37:
						break;
					case 37:
						{ return new Symbol(sym.IF); }
					case -38:
						break;
					case 38:
						{ return new Symbol(sym.FN); }
					case -39:
						break;
					case 39:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -40:
						break;
					case 40:
						{ return new Symbol(sym.REC); }
					case -41:
						break;
					case 41:
						{ return new Symbol(sym.END); }
					case -42:
						break;
					case 42:
						{ return new Symbol(sym.LET); }
					case -43:
						break;
					case 43:
						{ return new Symbol(sym.AND); }
					case -44:
						break;
					case 44:
						{ return new Symbol(sym.NOT); }
					case -45:
						break;
					case 45:
						{ return new Symbol(sym.NIL); }
					case -46:
						break;
					case 46:
						{ return new Symbol(sym.FUN); }
					case -47:
						break;
					case 47:
						{ return new Symbol(sym.VAL); }
					case -48:
						break;
					case 48:
						{ return new Symbol(sym.ELSE); }
					case -49:
						break;
					case 49:
						{ return new Symbol(sym.UNIT); }
					case -50:
						break;
					case 50:
						{ return new Symbol(sym.TRUE); }
					case -51:
						break;
					case 51:
						{ return new Symbol(sym.THEN); }
					case -52:
						break;
					case 52:
						{ return new Symbol(sym.LOCAL); }
					case -53:
						break;
					case 53:
						{ return new Symbol(sym.FALSE); }
					case -54:
						break;
					case 54:
						{ return new Symbol(sym.ORELSE, new OrElseCombinator()); }
					case -55:
						break;
					case 55:
						{ return new Symbol(sym.ANDALSO, new AndAlsoCombinator()); }
					case -56:
						break;
					case 56:
						{}
					case -57:
						break;
					case 57:
						{}
					case -58:
						break;
					case 58:
						{ yybegin(YYINITIAL); }
					case -59:
						break;
					case 59:
						{ System.err.println("End of File within comment"); 
                               return new Symbol(sym.EOF); }
					case -60:
						break;
					case 60:
						{}
					case -61:
						break;
					case 61:
						{ yybegin(YYINITIAL); }
					case -62:
						break;
					case 62:
						{ System.err.println("End of File within comment"); 
                               return new Symbol(sym.EOF); }
					case -63:
						break;
					case 63:
						{ return new Symbol(sym.EOF); }
					case -64:
						break;
					case 64:
						{ return new Symbol(sym.EOF); }
					case -65:
						break;
					case 66:
						{ System.err.println("Illegal character: "+yytext()); }
					case -66:
						break;
					case 67:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -67:
						break;
					case 68:
						{}
					case -68:
						break;
					case 69:
						{}
					case -69:
						break;
					case 71:
						{ System.err.println("Illegal character: "+yytext()); }
					case -70:
						break;
					case 72:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -71:
						break;
					case 73:
						{}
					case -72:
						break;
					case 75:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -73:
						break;
					case 77:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -74:
						break;
					case 79:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -75:
						break;
					case 81:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -76:
						break;
					case 83:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -77:
						break;
					case 85:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -78:
						break;
					case 87:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -79:
						break;
					case 89:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -80:
						break;
					case 91:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -81:
						break;
					case 93:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -82:
						break;
					case 95:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -83:
						break;
					case 97:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -84:
						break;
					case 98:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -85:
						break;
					case 99:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -86:
						break;
					case 100:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -87:
						break;
					case 101:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -88:
						break;
					case 102:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -89:
						break;
					case 103:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -90:
						break;
					case 104:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -91:
						break;
					case 105:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -92:
						break;
					case 106:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -93:
						break;
					case 107:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -94:
						break;
					case 108:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -95:
						break;
					case 109:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -96:
						break;
					case 110:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -97:
						break;
					case 111:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -98:
						break;
					case 112:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -99:
						break;
					case 113:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -100:
						break;
					case 114:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -101:
						break;
					case 115:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -102:
						break;
					case 116:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -103:
						break;
					case 117:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -104:
						break;
					case 118:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -105:
						break;
					case 119:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -106:
						break;
					case 120:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -107:
						break;
					case 121:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -108:
						break;
					case 122:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -109:
						break;
					case 123:
						{ return new Symbol(sym.NAME, new String(yytext())); }
					case -110:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
